		AREA	HelloW,CODE,READONLY
SWI_ANGEL EQU 0x123456		;SWI number for Angel semihosting	

		MACRO
$l		Exit					;Angel SWI call to terminate execution
$l		MOV		r0, #0x18		;select Angel SWIreason_ReportException(0x18)
		LDR     r1, =0x20026	;report ADP_Stopped_ApplicationExit
		SWI 	SWI_ANGEL		;ARM semihosting SWI
		MEND

		MACRO
$l		WriteC					;Angel SWI call to output character in [r1]
$l		MOV		r0, #0x3		;select Angel SYS_WRITEC function
		SWI		SWI_ANGEL
		MEND


		ENTRY					;code entry point
		ADR		r1, TEXT-1		;r1->"Hello World"
		MOV		r0, #0x3		;select Angel SYS_WRITEC
LOOP 	LDRB	r2, [r1,#1]!	;get next byte
		CMP		r2, #0			;check for text end
		SWINE	SWI_ANGEL		;if not end print...
		BNE		LOOP			;..and loop back
		Exit					;end of execution
		ALIGN					;to ensure ADR works
TEXT	DATA
		=		"Hello World",&a,&d,0
		END					;end of program source